	include "Hardware.inc"
	include "Macros.inc"
	SECTION "codetro", CODE

; variables (replayer uses from $df00 - $df4d)

TxtPtr		= $dffe	
ScrPtr		= $dffd
ChrPtr		= $dffc
padold		= $dffb
padnew		= $dffa
framecnt	= $dff9
ColPtr		= $dff8	
	
Start::

;	push af				; save GB type
	di
        xor	a
        ldh	[rIE],a         	; disable interrupts
;
	xor	a
	ld	[rSCY],a
	ld	[rSCX],a
	ld	[rSTAT],a
	ld	[rSVBK],a		; WorkRamBank=0
	ld	[rRP],a			; IR communication port (CLEAR to save power) 
	ld	[TxtPtr],a
	ld	[ScrPtr],a
	ld	[ChrPtr],a
	ld	[padold],a
	ld	[padnew],a
	ld	[framecnt],a
	ld	[ColPtr],a
;
	ld 	hl, _SCRN0		; clear VRAM
.clear
;	WVRam
	xor 	a
	ldio 	[rVBK], a		; set VRAM bank 0	
	nop
	ld 	[hl], a

	ld 	a, 1
	ldio 	[rVBK], a		; set VRAM bank 1	
	xor 	a
	ld 	[hl+], a
;
	ld 	a, h
	cp 	$9c
	jr 	nz, .clear

	xor 	a
	ldio 	[rVBK], a		; set VRAM bank 0	
;
;	WVRam
	jp	nix
	ld 	a, $80			; set colours
	ldio 	[rBCPS], a
	xor 	a
	ldio 	[rBCPD], a
	ldio 	[rBCPD], a
;hell
	ld 	a,$86
	ldio 	[rBCPS], a
	ld 	a,$0;de
	ldio 	[rBCPD], a
	ld 	a,$0;7b
	ldio 	[rBCPD], a
;dunkel
	ld 	a,$82
	ldio 	[rBCPS], a
	ld 	a,$0;e7
	ldio 	[rBCPD], a
	ld 	a,$0;1c
	ldio 	[rBCPD], a
;
	ld 	a,$84
	ldio 	[rBCPS], a
	ld 	a,$ff
	ldio 	[rBCPD], a
	ldio 	[rBCPD], a
;
nix::
	ld	hl,$9000+(("*"-32)*16)
	ld	bc,SpecChar
	ld	e,16
.setC
;	WVRam
	ld	a,[bc]
	inc	bc
	ld	[hl+],a
	dec	e
	jr	nz, .setC
;
	ld	hl,$8800
;	ld	bc,LogoData
;	ld	e,$78;(LogoDataEnd-LogoData)>>4
	ld	bc,TileData
	ld	e,144*40/8/8;(LogoDataEnd-LogoData)>>4
	nop
	ld	d,16
.lcop
;	WVRam
	ld	a,[bc]
	inc	bc
	ld	[hl+],a
	dec	d
	jr	nz,.lcop
	ld	d,16	
	dec	e
	jr	nz,.lcop
;
	ld	hl, _SCRN0
	ld	a,$80
	ld	e,18
	ld	d,5
.lset
	ld	[hl+],a
	inc	a
	dec	e
	jr	nz,.lset
	ld	bc,14
	add	hl,bc
	ld	e,18
	dec	d
	jr	nz,.lset

;	Enable LCD Display 
        ld	a,LCDCF_ON|LCDCF_BG8800|LCDCF_BG9800|LCDCF_BGON|LCDCF_OBJ8|LCDCF_OBJON
        ld	[rLCDC],a         	; Turn screen on
;
	xor	a
	ld	[rVBK],a
;

MainLoop::
	ld	a,-8
	ld	[rSCX],a
;	ld	hl,LogoCol
	ld	hl,PaletteData

; select Logo Col
	ld 	a,$80
	ldio 	[rBCPS], a
	ld	d,4
.lpal
	WVRam
; write Color
	ld	a,[hl+]	
	ldio 	[rBCPD], a
	ld	a,[hl+]	
	ldio 	[rBCPD], a
	dec	d
	jr	nz,.lpal
;
	ld	hl,FontColors
	ld	a,[framecnt]
	inc	a
	ld	[framecnt],a
	and	1
	jr	z,.notYet
;
	ld	a,[ColPtr]
	inc	a
	cp	64
	jr	c,.colOk
	xor	a
.colOk
	ld	[ColPtr],a
.notYet	
	ld	a,[ColPtr]

	add	a
	ld	b,0
	ld	c,a
	add	hl,bc
;
	ld	b,56				; num of lines
	ld	c,(8*8)-1			; start rasterline
.wvbl
	ldio 	a, [rLY]
	cp 	c				; wait for rasterline
	jr 	nz,.wvbl
;
	WVRam
;
; select Font Col
	ld 	a,$84
	ldio 	[rBCPS], a
;
; write Color
	ld	a,[hl+]	
	ldio 	[rBCPD], a
	ld	a,[hl+]	
	ldio 	[rBCPD], a
;
; next line
	inc	c
	dec	b

	ld	a,[ScrPtr]
	ld	[rSCX],a
	
	jr	nz,.wvbl


.vbl
	ldio 	a, [rLY]
	cp 	$90				; wait for VBL
	jr 	nz,.vbl
;
	call	PadRead
;
	call	BigScroller
;

	ld 	a, [padnew]
	or	a
	jr	z,MainLoop

	jp	trainer_menu
	ret		
	
	
BigScroller::
	ld	a,[ScrPtr]
;	inc	a
	add	2
	ld	[ScrPtr],a
	and	7
	ret	nz				; ready for new char ?

; calc new char pos in vram
	ld 	de, _SCRN0+(8*32)
	ld	a,[ScrPtr]
	add	168
	srl	a
	srl	a
	srl	a	;	
	add	e
	ld	e,a
;
; do we need a new char or just rotate the old ?
	ld	a,[ChrPtr]
	cp	7
	jr	nc,.newChr
;	
; get char and offset in Vram
	ld	a,[TxtPtr]
	ld	b,0
	ld	c,a	
	ld	hl,ScrollText
	add	hl,bc
	ld	a,[hl]
	ld	hl,$9000
;
	or	a
	jr	nz,.noEnd
;
	ld	[TxtPtr],a
	ld	hl,ScrollText
	ld	a,[hl]
;
.noEnd
	sub	32
	or	a
	jr	z,.nxt
	ld	c,16
.loopy
	add	hl,bc	
	dec	a
	jr	nz,.loopy
.nxt
;
; get bit mask
	ld	a,[ChrPtr]
	push	hl
	ld	hl,BitMask
	ld	b,0
	ld	c,a
	add	hl,bc
	ld	a,[hl]
	pop	hl
	ld	c,a	
;
	ld	b,7			; 7/8 rows, check font for real value!
; check bits of char
.loop
.wait1
	ldio 	a, [rSTAT]
	and 	2
	jr 	nz, .wait1

	inc	hl
	ld	a,[hl+]
	and	c
	jr	z,.not			; is bit set ?

	ld	a,"*"-32
	jr	.set
.not
	ld	a,0
.set
	ld	[de],a
	push	hl
	ld	h,0
	ld	l,32
	add	hl,de
	ld	d,h
	ld	e,l
	pop	hl
	dec	b
	jr	nz,.loop
	
	ld	a,[ChrPtr]
	inc	a
	ld	[ChrPtr],a

	ret
.newChr
	xor	a
	ld	[ChrPtr],a

; get new char	
	ld	a,[TxtPtr]	
	inc	a
	ld	[TxtPtr],a
;
	ld	a,[TxtPtr]	
	ld	hl,ScrollText
	add	l
	ld	l,a
	ld	a,[hl]
	or	a
	jr	nz,.ok
	ld	[TxtPtr],a
	ld	hl,ScrollText
	ld	a,[hl]
.ok	
	ret
	
Scroller::
	ld	a,[ScrPtr]
	inc	a
	ld	[ScrPtr],a
	and	7
	ret	nz
;	
	ld 	de, _SCRN0+(16*32)
	ld	a,[ScrPtr]
	add	168
	srl	a
	srl	a
	srl	a	
;	
	add	e
	ld	e,a
;
	ld	a,[TxtPtr]	
	inc	a
	ld	[TxtPtr],a
;
	ld	hl,ScrollText
	add	l
	ld	l,a
	ld	a,[hl]
	or	a
	jr	nz,.ok
	ld	[TxtPtr],a
	ld	hl,ScrollText
	ld	a,[hl]
.ok	
	ld	c,a
.wait
	ldio 	a, [rSTAT]
	and 	2
	jr 	nz, .wait
;	
	ld	a,c
	res	5,a
	sub	32
	ld	[de],a			; store converted char (a=A)
	ret
	
	
PadRead::
	ld 	a, $20
	ldio 	[rP1], a
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	cpl
	and 	$0f
	swap 	a
	ld 	b, a
	ld 	a, $10
	ldio 	[rP1], a
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	ldio 	a, [rP1]
	cpl
	and 	$0f
	or 	b
	ld 	[padnew], a
	ld 	a, $30
	ldio 	[rP1], a
	ret	
	

include "trainer.asm"

ScrollText::	
		DB	" HIGH SOCIETY IS BACK AND MOSHING AGAIN ... " 
		DB	"THIS TIME WE DECIDED TO TRAIN: "
		DB	"MR.NUTZ +3 !!! "
		DB	"AFTER CPL FORGOT TO INSERT THE LEVEL SELECTOR I DECIDED TO TRAIN IT AGAIN ... AND WK U KNOW I DID IT ALONE ;) "
		DB	" HIHOS TO ALL WHO DESERVE IT (NOT THAT MANY) !!!  FUCKINGS TO SINNER/PDX FOR BEING LAME ... "
		DB	"INTRO ZORN ...  FOR THE FIRE OF THE HANDGUN AND THE COLOR OF THE SINNER !!! "
		DB	" E.VIL N.EVER D.IES     "
		db	0	
BitMask:	
		db	128,64,32,16,8,4,2,1
FontColors::
DB $0E,$00, $4F,$08, $90,$10, $D1,$18, $12,$21, $53,$29, $94,$31, $D5,$39
DB $17,$42, $58,$4A, $99,$52, $DA,$5A, $1B,$63, $5C,$6B, $9D,$73, $DE,$7B
DB $9C,$73, $5A,$6B, $38,$63, $F6,$5A, $D4,$52, $92,$4A, $70,$42, $2E,$3A
DB $0C,$32, $CA,$29, $A8,$21, $66,$19, $44,$11, $02,$09, $E0,$00, $E2,$10
DB $E4,$20, $06,$35, $08,$45, $2A,$59, $2C,$69, $4E,$7D, $0C,$71, $EA,$64
DB $C8,$58, $A7,$4C, $65,$40, $43,$34, $21,$28, $63,$2C, $A5,$30, $E7,$38
DB $29,$3D, $6B,$41, $AD,$49, $EF,$4D, $31,$56, $73,$5A, $B5,$5E, $F7,$66
DB $39,$6B, $7B,$73, $BD,$77, $FF,$7B, $FA,$5A, $F6,$3D, $F1,$1C, $0D,$00

DB $0E,$00, $4F,$08, $90,$10, $D1,$18, $12,$21, $53,$29, $94,$31, $D5,$39
DB $17,$42, $58,$4A, $99,$52, $DA,$5A, $1B,$63, $5C,$6B, $9D,$73, $DE,$7B
DB $9C,$73, $5A,$6B, $38,$63, $F6,$5A, $D4,$52, $92,$4A, $70,$42, $2E,$3A
DB $0C,$32, $CA,$29, $A8,$21, $66,$19, $44,$11, $02,$09, $E0,$00, $E2,$10
DB $E4,$20, $06,$35, $08,$45, $2A,$59, $2C,$69, $4E,$7D, $0C,$71, $EA,$64
DB $C8,$58, $A7,$4C, $65,$40, $43,$34, $21,$28, $63,$2C, $A5,$30, $E7,$38
DB $29,$3D, $6B,$41, $AD,$49, $EF,$4D, $31,$56, $73,$5A, $B5,$5E, $F7,$66
DB $39,$6B, $7B,$73, $BD,$77, $FF,$7B, $FA,$5A, $F6,$3D, $F1,$1C, $0D,$00


SpecChar::
		db	%11111111,%11111111
		db	%10000001,%11111110
		db	%10000001,%11111110
		db	%10000001,%11111110
		db	%10000001,%11111110
		db	%10000001,%11111110
		db	%10000001,%11111110
		db	%11111111,%00000000

	
include "logo3.z80"

	