; decrunch the code+data into ram

	SECTION "Setup intro", CODE
	
	push af			; save GB type
	
	xor a
	ldio [$ff], a	; disable all interrupts
		
waitvbl
	ldio a, [$44]
	cp $90
	jr nz, waitvbl
	
	xor a
	ldio [$40], a	; turn off screen	
	
	ld hl, charset
	ld de, $c000
	call Unpack
	ld hl, $c000
	ld de, $9000
	ld bc, (1024/2)
	call eocopy


;	ld hl, logo
;	ld de, $c000
	;call Unpack
;	ld hl, $c000
	;ld de, $9400
;	ld bc, (672/2)
	;call eocopy
	
	ld hl, intro
	ld de, $c000
	call Unpack
	
	pop af			; restore GB type
	jp $c000		; start intro
	
charset	incbin "chars.rnc"	; these files must have the first 18 bytes removed
intro	incbin "cracktro.rnc"	
	
eocopy					; copy (bc*2) bytes from hl to de, for even/odd data only		
	push bc
	push de	
.eocopy1		
	ld a, [hli]
	ld [de], a		
	inc de
	inc de
	dec bc
	ld a, b			; check if bc = 0
	or c
	jr nz, .eocopy1
	pop de
	inc de
	pop bc
.eocopy2	
	ld a, [hli]
	ld [de], a
	inc de
	inc de
	dec bc
	ld a, b
	or c
	jr nz, .eocopy2
	ret
	
; slightly modified RNC method 2 depack routine

Unpack:
        SCF
        LD A,[HL+]      ; NOTE: This data fetch requires that the data
        ADC A,A         ; pointed to by HL is in one ROM bank and that the
        ADD A,A         ; fetch will not cross ROM boundaries.
        JP XLOOP

;---------------------------------------------------------

FETCH3:
        LD A,[hl+]
        ADC A,A
        jr BACK3
FETCH4:
        LD A,[hl+]
        ADC A,A
        jr BACK4
FETCH5:
        LD A,[hl+]
        ADC A,A
        Jr BACK5
FETCH6:
        LD A,[hl+]
        ADC A,A
        Jr BACK6
FETCH7:
        LD A,[hl+]
        ADC A,A
        jr BACK7
RAW:
        LD C,4
X4BITS:
        ADD A,A
        JR Z,FETCH7
BACK7:
        RL B
        DEC C
        JR NZ,X4BITS

        PUSH AF
        LD A,3
        ADD A,B
        ADD A,A
        LD C,A
RAWLPB:
        LD A,[hl+]
        LD [DE],A
        INC DE

        LD A,[hl+]
        LD [DE],A
        INC DE

        DEC C
        JR NZ,RAWLPB

        POP AF
        Jr XLOOP

;---------------------------------------------------------

FETCH0:
        LD A,[hl+]
        ADC A,A
        JR C,SMALLS
GETLEN:
        ADD A,A
        JR Z,FETCH3
BACK3:
        RL C
        ADD A,A
        JR Z,FETCH4
BACK4:
        JR NC,COPY
        ADD A,A
        JR Z,FETCH5
BACK5:
        DEC C
        PUSH HL

        LD H,A
        LD A,C
        ADC A,A
        LD C,A
        CP 9
        LD A,H

        POP HL
        JR Z,RAW

;---------------------------------------------------------

COPY:
        ADD A,A
        JR Z,FETCH6
BACK6:
        JR NC,BYTEDISP
        ADD A,A
        JR NZ,SKIP0
        LD A,[hl+]
        ADC A,A
SKIP0:
        RL B
        ADD A,A
        JR NZ,SKIP1
        LD A,[hl+]
        ADC A,A
SKIP1:
        JR C,BIGDISP
        INC B
        DEC B
        JR NZ,BYTEDISP
        INC B
ANOTHER:
        ADD A,A
        JR NZ,DISPX
        LD A,[hl+]
        ADC A,A
DISPX:
        RL B
BYTEDISP:
        PUSH AF
        LD A,E
        SUB [HL]
        PUSH HL
        LD L,A
        LD A,D
        SBC A,B
        LD H,A
        DEC HL
BYTELP:
        LD A,[hl+]
        LD [DE],A
        INC DE
        DEC C
        JR NZ,BYTELP

        POP HL
        INC HL

        POP AF
        JR XLOOP

;---------------------------------------------------------

GETBITS:
        LD A,[hl+]
        ADC A,A
        JR C,STRING
XBYTE:
        ld b,a          ; Took out 'push af' - JF, 99-Jul-25
        LD A,[hl+]
        LD [DE],A
        INC DE
        ld a,b          ; Took out 'pop af' - JF, 99-Jul-25
XLOOP:
        ADD A,A
        JR C,CHKZ

        ld b,a          ; Took out 'push af' - JF, 99-Jul-25
        LD A,[hl+]
        LD [DE],A
        INC DE
        ld a,b          ; Took out 'pop af' - JF, 99-Jul-25

        ADD A,A
        JR NC,XBYTE
CHKZ:
        JR Z,GETBITS

;---------------------------------------------------------

STRING:
        LD BC,2
        ADD A,A
        JR Z,FETCH0
        JR NC,GETLEN
SMALLS:
        ADD A,A
        JR Z,FETCH1
BACK1:
        JR NC,BYTEDISP

        INC C
        ADD A,A
        JR Z,FETCH2
BACK2:
        JR NC,COPY

        LD C,[HL]
        INC HL
        INC C
        DEC C
        JR Z,OVERNOUT

        PUSH AF

        LD A,C
        ADD A,8
        LD C,A

        POP AF
        Jr COPY

;---------------------------------------------------------

BIGDISP:
        ADD A,A
        JR NZ,SKIP2
        LD A,[hl+]
        ADC A,A
SKIP2:
        RL B
        SET 2,B
        ADD A,A
        JR NZ,SKIP3
        LD A,[hl+]
        ADC A,A
SKIP3:
        JR C,BYTEDISP
        Jr ANOTHER
FETCH1:
        LD A,[hl+]
        ADC A,A
        jr BACK1
FETCH2:
        LD A,[hl+]
        ADC A,A
        jr BACK2
OVERNOUT:
        ADD A,A
        JR NZ,CHECK4END

        LD A,[hl+]
        ADC A,A
CHECK4END:
        JR C,XLOOP
        RET
        
