; BOSS replayer routine version 1.0 - Berk/Paradox, 25/8/99
	
; ------------------------------ Variables -----------------------------------

varbase equ $df00	; change this if necessary (needs 77 bytes)

tick equ varbase
playflag equ varbase+1
retrig equ varbase+2
vibtemp equ varbase+3
duration_1 equ varbase+4
duration_2 equ varbase+5
duration_3 equ varbase+6
duration_4 equ varbase+7
adsr_stage_1 equ varbase+8
adsr_stage_2 equ varbase+9
adsr_stage_4 equ varbase+10
trk_ptr_1 equ varbase+11
trk_ptr_2 equ varbase+13
trk_ptr_3 equ varbase+15
trk_ptr_4 equ varbase+17
blk_ptr_1 equ varbase+19
blk_ptr_2 equ varbase+21
blk_ptr_3 equ varbase+23
blk_ptr_4 equ varbase+25
transpose_1 equ varbase+27
transpose_2 equ varbase+28
transpose_3 equ varbase+29
instr_ad_1 equ varbase+30
instr_sr_1 equ varbase+31
instr_va_1 equ varbase+32
instr_vdad_1 equ varbase+33
instr_ad_2 equ varbase+34
instr_sr_2 equ varbase+35
instr_va_2 equ varbase+36
instr_vdad_2 equ varbase+37
instr_ad_3 equ varbase+38
instr_sr_3 equ varbase+39
instr_va_3 equ varbase+40
instr_vdad_3 equ varbase+41
instr_ad_4 equ varbase+42
instr_sr_4 equ varbase+43
instr_va_4 equ varbase+44
instr_vdad_4 equ varbase+45
freq_lo_1 equ varbase+46
freq_hi_1 equ varbase+47
freq_lo_2 equ varbase+48
freq_hi_2 equ varbase+49
freq_lo_3 equ varbase+50
freq_hi_3 equ varbase+51
freq_lo_4 equ varbase+52
arp_delay_1 equ varbase+53
arp_pos_1 equ varbase+54
vib_delay_1 equ varbase+55
vib_pos_1 equ varbase+56
arp_delay_2 equ varbase+57
arp_pos_2 equ varbase+58
vib_delay_2 equ varbase+59
vib_pos_2 equ varbase+60
arp_delay_3 equ varbase+61
arp_pos_3 equ varbase+62
vib_delay_3 equ varbase+63
vib_pos_3 equ varbase+64
arp_delay_4 equ varbase+65
arp_pos_4 equ varbase+66
curr_note_1 equ varbase+67
old_note_1 equ varbase+68
curr_note_2 equ varbase+69
old_note_2 equ varbase+70
curr_note_3 equ varbase+71
old_note_3 equ varbase+72
curr_note_4 equ varbase+73
old_note_4 equ varbase+74
polynomial equ varbase+75
level equ varbase+76

; ----------------------------- Player code ---------------------------------- 

boss:
	jp initsong
	jp playsong
	jp stopsong
	
;	db "BOSS player v1.0 by Berk/Paradox", 0

initsong:	
	ld c, 77
	ld hl, varbase
	xor a
.clearvars
	ld [hli], a
	dec c
	jr nz, .clearvars
	
	ld a, 1
	ld [playflag], a		; no sound produced if flag is 0
	ld [tick], a			
	
	ld [duration_1], a		; set initial durations for each channel
	ld [duration_2], a
	ld [duration_3], a
	ld [duration_4], a
	
	ld a, 2
	ld [adsr_stage_1], a	; set adsr stage to 'finished'
	ld [adsr_stage_2], a
	ld [adsr_stage_4], a
				
	ld hl, dummy			; hl points to $ff byte
	ld a, l
	ld [trk_ptr_1], a		; set initial track and block pointers
	ld [trk_ptr_2], a
	ld [trk_ptr_3], a
	ld [trk_ptr_4], a
	ld [blk_ptr_1], a
	ld [blk_ptr_2], a
	ld [blk_ptr_3], a
	ld [blk_ptr_4], a
	ld a, h
	ld [trk_ptr_1+1], a
	ld [trk_ptr_2+1], a
	ld [trk_ptr_3+1], a
	ld [trk_ptr_4+1], a
	ld [blk_ptr_1+1], a
	ld [blk_ptr_2+1], a
	ld [blk_ptr_3+1], a
	ld [blk_ptr_4+1], a
	
	ld a, $80
	ldio [$26], a			; turn sound on
	ld a, $77
	ldio [$24], a			; full left & right volume
	ld a, $ff
	ldio [$25], a			; all channels to left & right outputs

	xor a
	ldio [$10], a			; mode 1 sweep 
	ldio [$12], a			; mode 1 envelope
	ldio [$17], a			; mode 2 envelope
	ldio [$1a], a			; mode 3 on/off
	ldio [$1b], a			; mode 3 length
	ldio [$1c], a			; mode 3 level
	ldio [$20], a			; mode 4 length
	ldio [$21], a			; mode 4 envelope
	ret
	
stopsong:
	xor a
	ldio [$26], a			; sound off
	ld [playflag], a		; sound routine will exit before doing anything
	ret

playsong:
	ld a, [playflag]
	or a
	ret z					; do nothing if playflag is 0
	
	ld a, [tick]
	dec a
	jp nz, effects			; do effects only if tick != 0
	
	ld a, [songspeed]
	ld [tick], a			; reset tick counter

channel1:					; handle sound channel 1
	ld a, [duration_1]
	dec a
	jr z, .getnextnote		; check duration
	ld [duration_1], a
	jp channel2				; go to next channel if duration != 0
	
.getnextnote:				; time to get next note
	ld a, 1
	ld [adsr_stage_1], a	; go to release stage of ADSR
	
	ld a, [blk_ptr_1]
	ld l, a
	ld a, [blk_ptr_1+1]
	ld h, a
	ld a, [hli]				; get next byte in current block
	cp $ff					; check if end of this block
	jr nz, .skipnewblock
	
	ld a, [trk_ptr_1]
	ld l, a
	ld a, [trk_ptr_1+1]
	ld h, a
	ld a, [hli]				; get next block number in the track
	cp $ff					; check if end of the track
	jr nz, .skiprestart
	
	ld hl, trk_1			; point hl back to start of the track
	ld a, [hli]				; get first block number

	cp $ff					; check again
	jr nz, .skiprestart
	dec hl					; move hl back to start
	dec hl					; move back 1 more, so after reading transpose hl is at start

.skiprestart:
	ld c, a
	ld a, [hli]				; get transpose value
	ld [transpose_1], a
	ld a, l
	ld [trk_ptr_1], a		; save track pointer
	ld a, h
	ld [trk_ptr_1+1], a
	
	ld a, c
	inc a					; check if $ff
	jp z, channel2			; leave if empty track
		
	sla c
	ld b, 0
	ld hl, blocklist	
	add hl, bc				; lookup addr of current block in the table
	ld d, h
	ld e, l
	ld a, [de]
	ld l, a
	inc de
	ld a, [de]
	ld h, a
	ld a, [hli]				; get first byte of the new block
	
.skipnewblock:				; a = current byte, hl = current addr in block
	ld c, a
	and $3f					; low 6 bits is note duration
	ld [duration_1], a
	ld a, c
	and $40					; check bit 6 (if set, dont retrigger adsr/wave/vib/arp)
	jr z, .doretrig
	xor a
	ld [retrig], a			; reset flag
.doretrig:	
	inc a
	ld [retrig], a			; set flag
	ld a, c
	and $80					; check bit 7 (if set, instrument follows)
	jr z, .noinstrument
	
	ld a, [hli]				; get instrument number
	ld c, a
	sla c
	sla c
	sla c					; c *= 8 (8 bytes per instrument)
	ld b, 0
	ld d, h
	ld e, l					; save hl
	ld hl, instruments
	add hl, bc				; add offset into table
	
	ld a, [hli]
	ld [instr_ad_1], a		; get attack/decay byte
	ld a, [hli]
	ld [instr_sr_1], a		; get sustain/release byte
	ld a, [hli]
	ld [instr_va_1], a		; get vibrato/arpeggio byte
	ld a, [hli]
	ld [instr_vdad_1], a	; get vibrato delay/arpeggio delay byte
	ld c, a
	and $0f
	ld [arp_delay_1], a		; set initial delay counter
	ld a, c
	swap a
	and $0f
	ld [vib_delay_1], a		; set initial delay counter
	ld a, [hli]				; get waveform/xxxx byte
	ld h, d
	ld l, e					; restore hl
	and $f0					; get waveform number
	sla a
	sla a
	ldio [$11], a			; set mode 1 waveform/length
	
.noinstrument:	
	ld a, [hli]				; get next byte (note number)
	ld c, a
	ld a, l
	ld [blk_ptr_1], a		; save block pointer
	ld a, h
	ld [blk_ptr_1+1], a

	ld a, c
	cp $40					; check if note = $40 (rest)
	jr nz, .handlenote
	ld [curr_note_1], a
	jr channel2				; jump to next channel

.handlenote:
	ld [curr_note_1], a		; save note number
	ld [old_note_1], a		; save it again, for effects
	ld b, 0
	ld a, [transpose_1]		; get transpose value
	add c					; add it to note number
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc				; lookup note table
	ld a, [retrig]
	or a					; check if flag is set
	jr z, .noretrig
	ld a, [instr_ad_1]
	or $08					; set increase bit
	ldio [$12], a			; set initial envelope
	xor a
	ld [arp_pos_1], a		; reset arpeggio
	ld [vib_pos_1], a		; reset vibrato
	ld [adsr_stage_1], a	; set adsr stage to attack
.noretrig:	
	ld a, [hli]		
	ldio [$13], a			; set low byte of frequency
	ld [freq_lo_1], a		; save it
	ld a, [hli]
	or $80
	ldio [$14], a			; hi byte of freq, inital bit set
	ld [freq_hi_1], a		; save it

channel2:					; handle sound channel 2
	ld a, [duration_2]
	dec a
	jr z, .getnextnote		; check duration
	ld [duration_2], a
	jp channel3				; go to next channel if duration != 0
	
.getnextnote:				; time to get next note
	ld a, 1
	ld [adsr_stage_2], a	; go to release stage of ADSR
	
	ld a, [blk_ptr_2]
	ld l, a
	ld a, [blk_ptr_2+1]
	ld h, a
	ld a, [hli]				; get next byte in current block
	cp $ff					; check if end of this block
	jr nz, .skipnewblock
	
	ld a, [trk_ptr_2]
	ld l, a
	ld a, [trk_ptr_2+1]
	ld h, a
	ld a, [hli]				; get next block number in the track
	cp $ff					; check if end of the track
	jr nz, .skiprestart
	
	ld hl, trk_2			; point hl back to start of the track
	ld a, [hli]				; get first block number

	cp $ff					; check again
	jr nz, .skiprestart
	dec hl					; move hl back to start
	dec hl					; move back 1 more, so after reading transpose hl is at start

.skiprestart:
	ld c, a
	ld a, [hli]				; get transpose value
	ld [transpose_2], a
	ld a, l
	ld [trk_ptr_2], a		; save track pointer
	ld a, h
	ld [trk_ptr_2+1], a
	
	ld a, c
	inc a					; check if $ff
	jp z, channel3			; leave if empty track
		
	sla c
	ld b, 0
	ld hl, blocklist	
	add hl, bc				; lookup addr of current block in the table
	ld d, h
	ld e, l
	ld a, [de]
	ld l, a
	inc de
	ld a, [de]
	ld h, a
	ld a, [hli]				; get first byte of the new block
	
.skipnewblock:				; a = current byte, hl = current addr in block
	ld c, a
	and $3f					; low 6 bits is note duration
	ld [duration_2], a
	ld a, c
	and $40					; check bit 6 (if set, dont retrigger adsr/wave/vib/arp)
	jr z, .doretrig
	xor a
	ld [retrig], a			; reset flag
.doretrig:	
	inc a
	ld [retrig], a			; set flag
	ld a, c
	and $80					; check bit 7 (if set, instrument follows)
	jr z, .noinstrument
	
	ld a, [hli]				; get instrument number
	ld c, a
	sla c
	sla c
	sla c					; c *= 8 (8 bytes per instrument)
	ld b, 0
	ld d, h
	ld e, l					; save hl
	ld hl, instruments
	add hl, bc				; add offset into table
	
	ld a, [hli]
	ld [instr_ad_2], a		; get attack/decay byte
	ld a, [hli]
	ld [instr_sr_2], a		; get sustain/release byte
	ld a, [hli]
	ld [instr_va_2], a		; get vibrato/arpeggio byte
	ld a, [hli]
	ld [instr_vdad_2], a	; get vibrato delay/arpeggio delay byte
	ld c, a
	and $0f
	ld [arp_delay_2], a		; set initial delay counter
	ld a, c
	swap a
	and $0f
	ld [vib_delay_2], a		; set initial delay counter
	ld a, [hli]				; get waveform/xxxx byte
	ld h, d
	ld l, e					; restore hl
	and $f0					; get waveform number
	sla a
	sla a
	ldio [$16], a			; set mode 2 waveform/length
	
.noinstrument:	
	ld a, [hli]				; get next byte (note number)
	ld c, a
	ld a, l
	ld [blk_ptr_2], a		; save block pointer
	ld a, h
	ld [blk_ptr_2+1], a

	ld a, c
	cp $40					; check if note = $40 (rest)
	jr nz, .handlenote
	ld [curr_note_2], a
	jr channel3				; jump to next channel

.handlenote:
	ld [curr_note_2], a		; save note number
	ld [old_note_2], a		; save it again, for effects
	ld b, 0
	ld a, [transpose_2]		; get transpose value
	add c					; add it to note number
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc				; lookup note table
	ld a, [retrig]
	or a					; check if flag is set
	jr z, .noretrig
	ld a, [instr_ad_2]
	or $08					; set increase bit
	ldio [$17], a			; set initial envelope
	xor a
	ld [arp_pos_2], a		; reset arpeggio
	ld [vib_pos_2], a		; reset vibrato
	ld [adsr_stage_2], a	; set adsr stage to attack
.noretrig:	
	ld a, [hli]		
	ldio [$18], a			; set low byte of frequency
	ld [freq_lo_2], a		; save it
	ld a, [hli]
	or $80
	ldio [$19], a			; hi byte of freq, inital bit set
	ld [freq_hi_2], a		; save it

channel3:					; handle sound channel 3
	ld a, [duration_3]
	dec a
	jr z, .getnextnote		; check duration
	ld [duration_3], a
	jp channel4				; go to next channel if duration != 0
	
.getnextnote:				; time to get next note
	xor a
	ldio [$1c], a			; mute mode 3
	
	ld a, [blk_ptr_3]
	ld l, a
	ld a, [blk_ptr_3+1]
	ld h, a
	ld a, [hli]				; get next byte in current block
	cp $ff					; check if end of this block
	jr nz, .skipnewblock
	
	ld a, [trk_ptr_3]
	ld l, a
	ld a, [trk_ptr_3+1]
	ld h, a
	ld a, [hli]				; get next block number in the track
	cp $ff					; check if end of the track
	jr nz, .skiprestart
	
	ld hl, trk_3			; point hl back to start of the track
	ld a, [hli]				; get first block number

	cp $ff					; check again
	jr nz, .skiprestart
	dec hl					; move hl back to start
	dec hl					; move back 1 more, so after reading transpose hl is at start

.skiprestart:
	ld c, a
	ld a, [hli]				; get transpose value
	ld [transpose_3], a
	ld a, l
	ld [trk_ptr_3], a		; save track pointer
	ld a, h
	ld [trk_ptr_3+1], a
	
	ld a, c
	inc a					; check if $ff
	jp z, channel4			; leave if empty track
		
	sla c
	ld b, 0
	ld hl, blocklist	
	add hl, bc				; lookup addr of current block in the table
	ld d, h
	ld e, l
	ld a, [de]
	ld l, a
	inc de
	ld a, [de]
	ld h, a
	ld a, [hli]				; get first byte of the new block
	
.skipnewblock:				; a = current byte, hl = current addr in block
	ld c, a
	and $3f					; low 6 bits is note duration
	ld [duration_3], a
	ld a, c
	and $40					; check bit 6 (if set, dont retrigger adsr/wave/vib/arp)
	jr z, .doretrig
	xor a
	ld [retrig], a			; reset flag
.doretrig:	
	inc a
	ld [retrig], a			; set flag
	ld a, c
	and $80					; check bit 7 (if set, instrument follows)
	jr z, .noinstrument
	
	ld a, [hli]				; get instrument number
	ld c, a
	sla c
	sla c
	sla c					; c *= 8 (8 bytes per instrument)
	ld b, 0
	ld d, h
	ld e, l					; save hl
	ld hl, instruments
	add hl, bc				; add offset into table
	
	ld a, [hli]
	ld [instr_ad_3], a		; get attack/decay byte
	ld a, [hli]
	ld [instr_sr_3], a		; get sustain/release byte
	ld a, [hli]
	ld [instr_va_3], a		; get vibrato/arpeggio byte
	ld a, [hli]
	ld [instr_vdad_3], a	; get vibrato delay/arpeggio delay byte
	ld c, a
	and $0f
	ld [arp_delay_3], a		; set initial delay counter
	ld a, c
	swap a
	and $0f
	ld [vib_delay_3], a		; set initial delay counter
	ld a, [hli]				; get waveform/level byte
	ld h, d
	ld l, e					; restore hl
	push hl					; save again :)
	ld d, a					; save level
	and $f0					; get waveform number (already << 4)
	ld hl, samples
	ld c, a
	ld b, 0
	add hl, bc				; hl points to sample data
	ld a, d
	and $0f					; get level
	swap a
	sla a
	ld [level], a			; set mode 3 level
	
	xor a
	ldio [$1c], a			; mute it 
	ldio [$1a], a			; turn off mode 3
		
	ld c, 16				; bytes to copy
	ld de, $ff30			; wave ram
.copy
	ld a, [hli]
	ld [de], a
	inc de
	dec c
	jr nz, .copy
	pop hl					; restore hl

	ld a, $80
	ldio [$1a], a			; turn on mode 3
	
.noinstrument:	
	ld a, [hli]				; get next byte (note number)
	ld c, a
	ld a, l
	ld [blk_ptr_3], a		; save block pointer
	ld a, h
	ld [blk_ptr_3+1], a

	ld a, c
	cp $40					; check if note = $40 (rest)
	jr nz, .handlenote
	ld [curr_note_3], a
	jr channel4				; jump to next channel

.handlenote:
	ld [curr_note_3], a		; save note number
	ld [old_note_3], a		; save it again, for effects
	ld b, 0
	ld a, [transpose_3]		; get transpose value
	add c					; add it to note number
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc				; lookup note table
	ld a, [retrig]
	or a					; check if flag is set
	jr z, .noretrig
	xor a
	ld [arp_pos_3], a		; reset arpeggio
	ld [vib_pos_3], a		; reset vibrato
.noretrig:	
	ld a, [level]			; set mode 3 level
	ldio [$1c], a
	ld a, [hli]		
	ldio [$1d], a			; set low byte of frequency
	ld [freq_lo_3], a		; save it
	ld a, [hli]
	or $80
	ldio [$1e], a			; hi byte of freq, inital bit set
	ld [freq_hi_3], a		; save it

channel4:					; handle sound channel 4
	ld a, [duration_4]
	dec a
	jr z, .getnextnote		; check duration
	ld [duration_4], a
	jp adsr					; exit if duration != 0
	
.getnextnote:				; time to get next note
	ld a, 1
	ld [adsr_stage_4], a	; go to release stage of ADSR
	
	ld a, [blk_ptr_4]
	ld l, a
	ld a, [blk_ptr_4+1]
	ld h, a
	ld a, [hli]				; get next byte in current block
	cp $ff					; check if end of this block
	jr nz, .skipnewblock
	
	ld a, [trk_ptr_4]
	ld l, a
	ld a, [trk_ptr_4+1]
	ld h, a
	ld a, [hli]				; get next block number in the track
	cp $ff					; check if end of the track
	jr nz, .skiprestart
	
	ld hl, trk_4			; point hl back to start of the track
	ld a, [hli]				; get first block number

	cp $ff					; check again
	jr nz, .skiprestart
	dec hl					; move hl back to start
	dec hl					; move back 1 more, so after reading transpose hl is at start

.skiprestart:
	ld c, a
	inc hl					; skip transpose value
	ld a, l
	ld [trk_ptr_4], a		; save track pointer
	ld a, h
	ld [trk_ptr_4+1], a
	
	ld a, c
	inc a					; check if $ff
	jp z, adsr				; leave if empty track
		
	sla c
	ld b, 0
	ld hl, blocklist	
	add hl, bc				; lookup addr of current block in the table
	ld d, h
	ld e, l
	ld a, [de]
	ld l, a
	inc de
	ld a, [de]
	ld h, a
	ld a, [hli]				; get first byte of the new block
	
.skipnewblock:				; a = current byte, hl = current addr in block
	ld c, a
	and $3f					; low 6 bits is note duration
	ld [duration_4], a
	ld a, c
	and $40					; check bit 6 (if set, dont retrigger adsr/wave/vib/arp)
	jr z, .doretrig
	xor a
	ld [retrig], a			; reset flag
.doretrig:	
	inc a
	ld [retrig], a			; set flag
	ld a, c
	and $80					; check bit 7 (if set, instrument follows)
	jr z, .noinstrument
	
	ld a, [hli]				; get instrument number
	ld c, a
	sla c
	sla c
	sla c					; c *= 8 (8 bytes per instrument)
	ld b, 0
	ld d, h
	ld e, l					; save hl
	ld hl, instruments
	add hl, bc				; add offset into table
	
	ld a, [hli]
	ld [instr_ad_4], a		; get attack/decay byte
	ld a, [hli]
	ld [instr_sr_4], a		; get sustain/release byte
	ld a, [hli]
	ld [instr_va_4], a		; get vibrato/arpeggio byte
	ld a, [hli]
	ld [instr_vdad_4], a	; get vibrato delay/arpeggio delay byte
	and $0f
	ld [arp_delay_4], a		; set initial delay counter
	ld a, [hli]				; get waveform/xxxx byte
	ld [polynomial], a		; save it
	ld h, d
	ld l, e					; restore hl
		
.noinstrument:	
	ld a, [hli]				; get next byte (note number)
	ld c, a
	ld a, l
	ld [blk_ptr_4], a		; save block pointer
	ld a, h
	ld [blk_ptr_4+1], a

	ld a, c
	cp $40					; check if note = $40 (rest)
	jr nz, .handlenote
	ld [curr_note_4], a
	jp adsr					; leave

.handlenote:
	ld [curr_note_4], a		; save note number
	ld b, 0
	ld a, [retrig]
	or a					; check if flag is set
	jr z, .noretrig
	ld a, [instr_ad_4]
	or $08					; set increase bit
	ldio [$21], a			; set initial envelope
	xor a
	ld [arp_pos_4], a		; reset arpeggio
	ld [adsr_stage_4], a	; set adsr stage to attack
.noretrig:	
	ld a, [polynomial]		
	ldio [$22], a			; set low byte of frequency
	ld [freq_lo_4], a		; save it
	ld a, $80
	ldio [$23], a			; set inital bit
	jp adsr

effects:
	ld [tick], a
	
effects1:					; handle fx for channel 1
	ld a, [old_note_1]
	ld [retrig], a			; use retrig as a temp variable
	
	ld a, [arp_delay_1]
	dec a					; check delay counter
	ld [arp_delay_1], a
	jr nz, .vibrato			
.arpeggio
	ld a, [instr_vdad_1]
	and $0f
	ld [arp_delay_1], a		; reset delay counter
	ld a, [instr_va_1]
	and $0f					; get arpeggio number
	swap a					; a <<= 4 (16 bytes per arpeggio table)
	ld c, a
	ld b, 0
	ld hl, arpeggio
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [arp_pos_1]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .vibrato			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetarp
	inc hl
	ld a, [hl]				; get loop pos
	ld [arp_pos_1], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .vibrato			; exit if table is empty
.noresetarp:
	ld hl, arp_pos_1
	inc [hl]				; since we are using a byte, inc the ptr
	ld c, a
	ld a, [old_note_1]		; get old_note, not curr_note
	add c					; add value from arpeggio table
	ld [retrig], a			; use retrig as a temp variable

.vibrato:
	xor a
	ld [vibtemp], a			; set vibrato offset to 0 at first
	ld a, [vib_delay_1]
	dec a					; check delay counter
	ld [vib_delay_1], a
	jr nz, .finish			
	ld a, [instr_vdad_1]
	swap a
	and $0f
	ld [vib_delay_1], a		; reset delay counter
	ld a, [instr_va_1]
	and $f0					; get vibrato number (and its already << 4)
	ld c, a
	ld b, 0
	ld hl, vibrato
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [vib_pos_1]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .finish			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetvib
	inc hl
	ld a, [hl]				; get loop pos
	ld [vib_pos_1], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .finish			; exit if table is empty
.noresetvib:
	ld hl, vib_pos_1
	inc [hl]				; since we are using a byte, inc the ptr
	ld [vibtemp], a
.finish:	
	ld a, [retrig]			; get note number
	ld c, a
	ld a, [transpose_1]		; get transpose value
	add c					; add it
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc
	ld a, [vibtemp]			; get vibrato offset
	ld b, 0
	bit 7, a				; check if negative
	jr z, .usevibrato
	dec b					; make it $ff
.usevibrato:	
	ld c, a
	ld a, [hli]
	ld e, a
	ld a, [hl]
	ld h, a
	ld l, e					; hl = freq
	add hl, bc				; add vibrato value
	ld a, l
	ldio [$13], a			; mode 1 freq lo
	ld [freq_lo_1], a
	ld a, h
	ldio [$14], a			; mode 1 freq hi (initial bit not set)
	ld [freq_hi_1], a

effects2:
	ld a, [old_note_2]
	ld [retrig], a			; use retrig as a temp variable
	
	ld a, [arp_delay_2]
	dec a					; check delay counter
	ld [arp_delay_2], a
	jr nz, .vibrato			
.arpeggio
	ld a, [instr_vdad_2]
	and $0f
	ld [arp_delay_2], a		; reset delay counter
	ld a, [instr_va_2]
	and $0f					; get arpeggio number
	swap a					; a <<= 4 (16 bytes per arpeggio table)
	ld c, a
	ld b, 0
	ld hl, arpeggio
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [arp_pos_2]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .vibrato			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetarp
	inc hl
	ld a, [hl]				; get loop pos
	ld [arp_pos_2], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .vibrato			; exit if table is empty
.noresetarp:
	ld hl, arp_pos_2
	inc [hl]				; since we are using a byte, inc the ptr
	ld c, a
	ld a, [old_note_2]		; get old_note, not curr_note
	add c					; add value from arpeggio table
	ld [retrig], a			; use retrig as a temp variable

.vibrato:
	xor a
	ld [vibtemp], a			; set vibrato offset to 0 at first
	ld a, [vib_delay_2]
	dec a					; check delay counter
	ld [vib_delay_2], a
	jr nz, .finish			
	ld a, [instr_vdad_2]
	swap a
	and $0f
	ld [vib_delay_2], a		; reset delay counter
	ld a, [instr_va_2]
	and $f0					; get vibrato number (and its already << 4)
	ld c, a
	ld b, 0
	ld hl, vibrato
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [vib_pos_2]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .finish			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetvib
	inc hl
	ld a, [hl]				; get loop pos
	ld [vib_pos_2], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .finish			; exit if table is empty
.noresetvib:
	ld hl, vib_pos_2
	inc [hl]				; since we are using a byte, inc the ptr
	ld [vibtemp], a
.finish:	
	ld a, [retrig]			; get note number
	ld c, a
	ld a, [transpose_2]		; get transpose value
	add c					; add it
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc
	ld a, [vibtemp]			; get vibrato offset
	ld b, 0
	bit 7, a
	jr z, .usevibrato
	dec b
.usevibrato:	
	ld c, a
	ld a, [hli]
	ld e, a
	ld a, [hl]
	ld h, a
	ld l, e					; hl = freq
	add hl, bc				; add vibrato value
	ld a, l
	ldio [$18], a			; mode 2 freq lo
	ld [freq_lo_2], a
	ld a, h
	ldio [$19], a			; mode 2 freq hi (initial bit not set)
	ld [freq_hi_2], a
	
effects3:
	ldio a, [$1a]
	or a
	jp z, effects4			; dont do fx if mode 3 is off
	
	ld a, [old_note_3]
	ld [retrig], a			; use retrig as a temp variable
	
	ld a, [arp_delay_3]
	dec a					; check delay counter
	ld [arp_delay_3], a
	jr nz, .vibrato			
.arpeggio
	ld a, [instr_vdad_3]
	and $0f
	ld [arp_delay_3], a		; reset delay counter
	ld a, [instr_va_3]
	and $0f					; get arpeggio number
	swap a					; a <<= 4 (16 bytes per arpeggio table)
	ld c, a
	ld b, 0
	ld hl, arpeggio
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [arp_pos_3]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .vibrato			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetarp
	inc hl
	ld a, [hl]				; get loop pos
	ld [arp_pos_3], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .vibrato			; exit if table is empty
.noresetarp:
	ld hl, arp_pos_3
	inc [hl]				; since we are using a byte, inc the ptr
	ld c, a
	ld a, [old_note_3]		; get old_note, not curr_note
	add c					; add value from arpeggio table
	ld [retrig], a			; use retrig as a temp variable

.vibrato:
	xor a
	ld [vibtemp], a			; set vibrato offset to 0 at first
	ld a, [vib_delay_3]
	dec a					; check delay counter
	ld [vib_delay_3], a
	jr nz, .finish			
	ld a, [instr_vdad_3]
	swap a
	and $0f
	ld [vib_delay_3], a		; reset delay counter
	ld a, [instr_va_3]
	and $f0					; get vibrato number (and its already << 4)
	ld c, a
	ld b, 0
	ld hl, vibrato
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [vib_pos_3]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, .finish			; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetvib
	inc hl
	ld a, [hl]				; get loop pos
	ld [vib_pos_3], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $81
	jp z, .finish			; exit if table is empty
.noresetvib:
	ld hl, vib_pos_3
	inc [hl]				; since we are using a byte, inc the ptr
	ld [vibtemp], a
.finish:	
	ld a, [retrig]			; get note number
	ld c, a
	ld a, [transpose_3]		; get transpose value
	add c					; add it
	ld c, a
	sla c
	ld hl, notetable
	add hl, bc
	ld a, [vibtemp]			; get vibrato offset
	ld b, 0
	bit 7, a
	jr z, .usevibrato
	dec b
.usevibrato:
	ld c, a	
	ld a, [hli]
	ld e, a
	ld a, [hl]
	ld h, a
	ld l, e					; hl = freq
	add hl, bc				; add vibrato value
	ld a, l
	ldio [$1d], a			; mode 3 freq lo
	ld [freq_lo_3], a
	ld a, h
	ldio [$1e], a			; mode 3 freq hi (initial bit not set)
	ld [freq_hi_3], a

effects4:
	ld a, [arp_delay_4]
	dec a					; check delay counter
	ld [arp_delay_4], a
	jr nz, .finish			; no vibrato on mode 4			
.arpeggio
	ld a, [freq_lo_4]
	ld [retrig], a
	ld a, [instr_vdad_4]
	and $0f
	ld [arp_delay_4], a		; reset delay counter
	ld a, [instr_va_4]
	and $0f					; get arpeggio number
	swap a					; a <<= 4 (16 bytes per arpeggio table)
	ld c, a
	ld b, 0
	ld hl, arpeggio
	add hl, bc
	ld d, h					; save the address of the start of the table
	ld e, l
	ld a, [arp_pos_4]		; get offset into data
	ld c, a
	add hl, bc
	ld a, [hl]
	cp $80
	jr z, adsr				; check for end byte ($80 = stop, $81 = loop)
	cp $81					; check for end of data
	jp nz, .noresetarp
	inc hl
	ld a, [hl]				; get loop pos
	ld [arp_pos_4], a
	ld h, d
	ld l, e					; point back to start of data
	ld c, a
	add hl, bc				; add offset
	ld a, [hl]				; get byte 
	cp $80
	jp z, .finish			; exit if table is empty
	ld [retrig], a			; temp storage
.noresetarp:
	ld [retrig], a
	ld hl, arp_pos_4
	inc [hl]				; since we are using a byte, inc the ptr
.finish:	
	ld a, [retrig]
	ldio [$22], a			; mode 4 polynomial etc.
	ld [freq_lo_4], a
	ld a, $80
	ldio [$23], a			; set initial bit
	
	; fall through to adsr
		
adsr:
	ld a, [adsr_stage_1]
	dec a					; stage 1 = release
	jp nz, adsr_2
	ld hl, adsr_stage_1
	inc [hl]				; goto next stage
	ld a, [instr_sr_1]
	ldio [$12], a			; set envelope
	ld a, [freq_lo_1]
	ldio [$13], a
	ld a, [freq_hi_1]
	or $80
	ldio [$14], a			; set freq, initial set

adsr_2:
	ld a, [adsr_stage_2]
	dec a					; stage 1 = release
	jp nz, adsr_4
	ld hl, adsr_stage_2
	inc [hl]				; goto next stage
	ld a, [instr_sr_2]
	ldio [$17], a			; set envelope
	ld a, [freq_lo_2]
	ldio [$18], a
	ld a, [freq_hi_2]
	or $80
	ldio [$19], a			; set freq, initial set

adsr_4:
	ld a, [adsr_stage_4]
	dec a					; stage 1 = release
	ret nz
	ld hl, adsr_stage_4
	inc [hl]				; goto next stage
	ld a, [instr_sr_4]
	ldio [$21], a			; set envelope
	ld a, [freq_lo_4]
	or $80
	ldio [$22], a			; set freq, initial set
	ret

dummy:	db $ff

notetable:
	db $2c, $00, $9c, $00, $06, $01, $6b, $01, $c9, $01, $23, $02, $77, $02, $c6, $02
	db $12, $03, $56, $03, $9b, $03, $da, $03, $16, $04, $4e, $04, $83, $04, $b5, $04
	db $e5, $04, $11, $05, $3b, $05, $63, $05, $89, $05, $ac, $05, $ce, $05, $ed, $05
	db $0a, $06, $27, $06, $42, $06, $5b, $06, $72, $06, $89, $06, $9e, $06, $b2, $06
	db $c4, $06, $d6, $06, $e7, $06, $f7, $06, $06, $07, $14, $07, $21, $07, $2d, $07
	db $39, $07, $44, $07, $4f, $07, $59, $07, $62, $07, $6b, $07, $73, $07, $7b, $07
	db $83, $07, $8a, $07, $90, $07, $97, $07, $9d, $07, $a2, $07, $a7, $07, $ac, $07
	db $b1, $07, $b6, $07, $ba, $07, $be, $07, $c1, $07, $c4, $07, $c8, $07, $cb, $07
	db $ce, $07, $d1, $07, $d4, $07, $d6, $07, $d9, $07, $db, $07, $dd, $07, $df, $07

; --------------------------------- EOF --------------------------------------

